"use strict";

/**
 * Converts comma separated query parameters into string arrays
 * on the request object.
 */
module.exports = function queryArrayParser(options) {
  if (typeof options === 'string') {
    options = {
      paramNames: options
    }
  }

  var paramNames = options.paramNames;
  var delim = options.delim || ',';

  // Make paramNames an array
  if (typeof paramNames === 'string') {
    paramNames = [paramNames];
  }

  return function(req, res, next) {
    paramNames.forEach(function(param) {
      if (req.query[param]) {
        req.query[param] = req.query[param].split(delim);
      }
    });

    next();
  }
};
